# include "Tools.h"

int MovingAverage1(int oldS, long t, long * t_holding_period, int nslow, int nfast, int c, double b, double * Prices) {
//two MAs, constant holding period, percentage band filter
	int S;
	if((t-*t_holding_period)<c)
  		S=oldS;
	else {
		double slow_avrg=Average(Prices, t-nslow+1, t);
		double fast_avrg=Average(Prices, t-nfast+1, t);
		if(fast_avrg>(1+b)*slow_avrg) {
			S=1;
			*t_holding_period=t;
		} else if(fast_avrg<(1-b)*slow_avrg) {
			S=-1;
			*t_holding_period=t;
		} else
			S=0;
	}
	return S;
}

int MovingAverage2(long t, int nslow, int nfast, int d, double * Prices) {
//two MAs, time delay
	int S=1;
	int i=0;
	double slow_avrg;
	double fast_avrg;
	while(i<d && S!=0){
		slow_avrg=Average(Prices, t-nslow+1-i, t-i);
		fast_avrg=Average(Prices, t-nfast+1-i, t-i);
		if(i==0 && fast_avrg>slow_avrg)
			S=1;
		else if(i==0 && fast_avrg<=slow_avrg)
			S=-1;
		else if((fast_avrg>slow_avrg && S==-1) || (fast_avrg<=slow_avrg && S==1))
			S=0;
		i++;
	}
	return S;
}