#include "Tools.h"

int ChannelBreakouts(int oldS, long t, long * pt_holding_period, int n, double x, int c, double b, double* Prices) {
	double high, low;
	int S=0;
	if((t-*pt_holding_period)<c) {
  		S=oldS;
	} else {
        high=FindHigh(Prices, t-n, t-1);
		low=FindLow(Prices, t-n, t-1);
		if((high-low)/low<=x) {
			if(Prices[t]>high*(1+b)) {
				S=1;
				*pt_holding_period=t;
			} else if(Prices[t]<low*(1-b)) {
				S=-1;
				*pt_holding_period=t;
			}
		}
	}
	return S;
}