% Generate random numbers for C++ program

clear all
close all
clc

% Jan 1897 - Dec 1914
% period='1';
% TT=5273;
% Jan 1915 - Dec 1938
% period='2';
% TT=7165;
% Jan 1939 - June 1962
% period='3';
% TT=6443;
% July 1962 - Dec 1986
% period='4';
% TT=6157;
% Jan 1987 - Dec 1996
% period='5';
% TT=2529;
% Jan 1997 - July 2011
period='6';
TT=3658;
% Jan 1897 - Dec 1986
% period='90';
% TT=25038;
% Jan 1897 - Dec 1996
% period='100';
% TT=27567;

% pers 1 an
% period='pers1an';
% TT=251+252;
% pers 2 ans
% period='pers2ans';
% TT=251+2*252;
% pers 6 mois
% period='pers6mois';
% TT=251+252/2;
% pers 1 mois
% period='pers1mois';
% TT=251+252/12;


R=251;
T=TT-1;
N=T-R+1;

B=1000;
q=1/10;

IDX=zeros(N,B);

for b=1:B
    IDX(1,b)=unidrnd(N)-1;
    U=unifrnd(0,1,N-1,1);
    ind1=find(U<q)+1;
    ind2=find(U>=q)+1;
    IDX(ind1,b)=unidrnd(N,length(ind1),1)-1;
    for i=1:length(ind2)
        t=ind2(i);
        IDX(t,b)=IDX(t-1,b)+1;
        if IDX(t,b)>(N-1)
            IDX(t,b)=0;            
        end
    end
end

fid=fopen(['C:\DATA\dataprojet1\data\IDX_P' period '.txt'],'wt');
for b=1:B
    fprintf(fid,'% 4.0f\n',IDX(:,b));
end
fclose(fid);


