#include <cstdlib>
#include <cmath>

#include <string>
#include <fstream>
#include <iostream>
#include <sstream>

#include "Umgebung.h"

using namespace std;

extern double DJ[TT_];
extern double DJ_Returns[TT_];

void infos(int SSS[][N_], infos_struct ALL_Infos[]) {

	int s;
	long t;

	double tmp_return, tmp_nb_days;
	long t_begin_trade;

	long tmp_nb_trades, tmp_nb_w_trades, tmp_nb_l_trades;
	double tmp_nb_days_all_trades, tmp_nb_days_w_trades, tmp_nb_days_l_trades;
	double tmp_return_all_trades, tmp_return_w_trades, tmp_return_l_trades;

	long tmp_nb_trades_L, tmp_nb_w_trades_L, tmp_nb_l_trades_L;
	double tmp_nb_days_all_trades_L, tmp_nb_days_w_trades_L, tmp_nb_days_l_trades_L;
	double tmp_return_all_trades_L, tmp_return_w_trades_L, tmp_return_l_trades_L;

	long tmp_nb_trades_S, tmp_nb_w_trades_S, tmp_nb_l_trades_S;
	double tmp_nb_days_all_trades_S, tmp_nb_days_w_trades_S, tmp_nb_days_l_trades_S;
	double tmp_return_all_trades_S, tmp_return_w_trades_S, tmp_return_l_trades_S;

	long tmp_nb_transacs;

	double tmp_winning_signals, tmp_neutral_signals, tmp_losing_signals;

	for(s=0; s<nb_strats_; s++) {
		t_begin_trade=-1;

		tmp_nb_trades=0;
		tmp_nb_w_trades=0;
		tmp_nb_l_trades=0;
		tmp_nb_days_all_trades=0;
		tmp_nb_days_w_trades=0;
		tmp_nb_days_l_trades=0;
		tmp_return_all_trades=0;
		tmp_return_w_trades=0;
		tmp_return_l_trades=0;

		tmp_nb_trades_L=0;
		tmp_nb_w_trades_L=0;
		tmp_nb_l_trades_L=0;
		tmp_nb_days_all_trades_L=0;
		tmp_nb_days_w_trades_L=0;
		tmp_nb_days_l_trades_L=0;
		tmp_return_all_trades_L=0;
		tmp_return_w_trades_L=0;
		tmp_return_l_trades_L=0;
		
		tmp_nb_trades_S=0;
		tmp_nb_w_trades_S=0;
		tmp_nb_l_trades_S=0;
		tmp_nb_days_all_trades_S=0;
		tmp_nb_days_w_trades_S=0;
		tmp_nb_days_l_trades_S=0;
		tmp_return_all_trades_S=0;
		tmp_return_w_trades_S=0;
		tmp_return_l_trades_S=0;

		tmp_nb_transacs=0;

		tmp_winning_signals=0;
		tmp_neutral_signals=0;
		tmp_losing_signals=0;

		if(SSS[s][R_-1]!=0) {
			t_begin_trade=R_;
		}
		for(t=R_; t<T_; t++) {
			if(SSS[s][t]==0) {
				tmp_neutral_signals++;
			} else {
				if((SSS[s][t]==1 && DJ_Returns[t+1]>0) || (SSS[s][t]==-1 && DJ_Returns[t+1]<0)) {
					tmp_winning_signals++;
				} else {
					tmp_losing_signals++;
				}
			}

			if(SSS[s][t]!=SSS[s][t-1]) {
				if(SSS[s][t]*SSS[s][t-1]==0) {
					tmp_nb_transacs++;
				} else {
					tmp_nb_transacs+=2;
				}
				if(t_begin_trade!=-1 && SSS[s][t_begin_trade-1]!=0) {
					tmp_nb_days=t-t_begin_trade+1;
					tmp_return=SSS[s][t_begin_trade-1] * (log(DJ[t])-log(DJ[t_begin_trade]));
					
					tmp_nb_trades++;
					tmp_nb_days_all_trades+=tmp_nb_days;
					tmp_return_all_trades+=tmp_return;
					if(tmp_return>0) {
						tmp_nb_w_trades++;
						tmp_nb_days_w_trades+=tmp_nb_days;
						tmp_return_w_trades+=tmp_return;
					} else {
						tmp_nb_l_trades++;
						tmp_nb_days_l_trades+=tmp_nb_days;
						tmp_return_l_trades+=tmp_return;
					}

					if(SSS[s][t_begin_trade-1]==1) {
						tmp_nb_trades_L++;
						tmp_nb_days_all_trades_L+=tmp_nb_days;
						tmp_return_all_trades_L+=tmp_return;
						if(tmp_return>0) {
							tmp_nb_w_trades_L++;
							tmp_nb_days_w_trades_L+=tmp_nb_days;
							tmp_return_w_trades_L+=tmp_return;
						} else {
							tmp_nb_l_trades_L++;
							tmp_nb_days_l_trades_L+=tmp_nb_days;
							tmp_return_l_trades_L+=tmp_return;
						}
					} else {
						tmp_nb_trades_S++;
						tmp_nb_days_all_trades_S+=tmp_nb_days;
						tmp_return_all_trades_S+=tmp_return;
						if(tmp_return>0) {
							tmp_nb_w_trades_S++;
							tmp_nb_days_w_trades_S+=tmp_nb_days;
							tmp_return_w_trades_S+=tmp_return;
						} else {
							tmp_nb_l_trades_S++;
							tmp_nb_days_l_trades_S+=tmp_nb_days;
							tmp_return_l_trades_S+=tmp_return;
						}
					}
				}
				t_begin_trade=t+1;
			}
		}
		ALL_Infos[s].nb_trades=tmp_nb_trades;
		ALL_Infos[s].nb_w_trades=tmp_nb_w_trades;
		ALL_Infos[s].nb_l_trades=tmp_nb_l_trades;
		ALL_Infos[s].nb_days_per_trade= tmp_nb_trades==0 ? 0 : tmp_nb_days_all_trades/tmp_nb_trades;
		ALL_Infos[s].nb_days_per_w_trade= tmp_nb_w_trades==0 ? 0 : tmp_nb_days_w_trades/tmp_nb_w_trades;
		ALL_Infos[s].nb_days_per_l_trade= tmp_nb_l_trades==0 ? 0 : tmp_nb_days_l_trades/tmp_nb_l_trades;
		//ALL_Infos[s].return_per_trade= tmp_nb_trades==0 ? 0 : ((T_fin_year_/tmp_nb_days_all_trades) * tmp_return_all_trades) / tmp_nb_trades;
		ALL_Infos[s].return_per_trade= tmp_nb_trades==0 ? 0 : tmp_return_all_trades/tmp_nb_trades;
		ALL_Infos[s].return_per_w_trade= tmp_nb_w_trades==0 ? 0 : tmp_return_w_trades/tmp_nb_w_trades;
		ALL_Infos[s].return_per_l_trade= tmp_nb_l_trades==0 ? 0 : tmp_return_l_trades/tmp_nb_l_trades;

		ALL_Infos[s].nb_trades_L=tmp_nb_trades_L;
		ALL_Infos[s].nb_w_trades_L=tmp_nb_w_trades_L;
		ALL_Infos[s].nb_l_trades_L=tmp_nb_l_trades_L;
		ALL_Infos[s].nb_days_per_trade_L= tmp_nb_trades_L==0 ? 0 : tmp_nb_days_all_trades_L/tmp_nb_trades_L;
		ALL_Infos[s].nb_days_per_w_trade_L= tmp_nb_w_trades_L==0 ? 0 : tmp_nb_days_w_trades_L/tmp_nb_w_trades_L;
		ALL_Infos[s].nb_days_per_l_trade_L= tmp_nb_l_trades_L==0 ? 0 : tmp_nb_days_l_trades_L/tmp_nb_l_trades_L;
		ALL_Infos[s].return_per_trade_L= tmp_nb_trades_L==0 ? 0 : tmp_return_all_trades_L/tmp_nb_trades_L;
		ALL_Infos[s].return_per_w_trade_L= tmp_nb_w_trades_L==0 ? 0 : tmp_return_w_trades_L/tmp_nb_w_trades_L;
		ALL_Infos[s].return_per_l_trade_L= tmp_nb_l_trades_L==0 ? 0 : tmp_return_l_trades_L/tmp_nb_l_trades_L;

		ALL_Infos[s].nb_trades_S=tmp_nb_trades_S;
		ALL_Infos[s].nb_w_trades_S=tmp_nb_w_trades_S;
		ALL_Infos[s].nb_l_trades_S=tmp_nb_l_trades_S;
		ALL_Infos[s].nb_days_per_trade_S= tmp_nb_trades_S==0 ? 0 : tmp_nb_days_all_trades_S/tmp_nb_trades_S;
		ALL_Infos[s].nb_days_per_w_trade_S= tmp_nb_w_trades_S==0 ? 0 : tmp_nb_days_w_trades_S/tmp_nb_w_trades_S;
		ALL_Infos[s].nb_days_per_l_trade_S= tmp_nb_l_trades_S==0 ? 0 : tmp_nb_days_l_trades_S/tmp_nb_l_trades_S;
		ALL_Infos[s].return_per_trade_S= tmp_nb_trades_S==0 ? 0 : tmp_return_all_trades_S/tmp_nb_trades_S;
		ALL_Infos[s].return_per_w_trade_S= tmp_nb_w_trades_S==0 ? 0 : tmp_return_w_trades_S/tmp_nb_w_trades_S;
		ALL_Infos[s].return_per_l_trade_S= tmp_nb_l_trades_S==0 ? 0 : tmp_return_l_trades_S/tmp_nb_l_trades_S;

		ALL_Infos[s].nb_transacs=tmp_nb_transacs;

		ALL_Infos[s].prop_winning_signals=tmp_winning_signals/N_;
		ALL_Infos[s].prop_neutral_signals=tmp_neutral_signals/N_;
		ALL_Infos[s].prop_losing_signals=tmp_losing_signals/N_;
	}

}

void port_nb_transacs(int Portfolio[], int SSS[][N_], infos_struct * Port_Infos) {

	int s;
	long t;
	long tmp_nb_buys, tmp_nb_sells, tmp_nb_transacs;

	tmp_nb_transacs=0;

	ofstream TestFile;
	TestFile.open("exposure.txt", ofstream::out | ofstream::trunc);
	
	for(t=R_; t<T_; t++) {
		tmp_nb_buys=0;
		tmp_nb_sells=0;
		for(s=0; s<nb_strats_; s++) {
			if(Portfolio[s]==1) {
				if(SSS[s][t]!=SSS[s][t-1]) {
					if(SSS[s][t]*SSS[s][t-1]==0) {
						if(SSS[s][t-1]<SSS[s][t]) {
                            tmp_nb_buys++;
						} else {
							tmp_nb_sells++;
						}
					} else {
						if(SSS[s][t-1]<SSS[s][t]) {
                            tmp_nb_buys+=2;
						} else {
							tmp_nb_sells+=2;
						}
					}
				}
			}
		}
		tmp_nb_transacs+=abs(tmp_nb_buys-tmp_nb_sells);

		TestFile << tmp_nb_buys-tmp_nb_sells << endl;
	}
	Port_Infos->nb_transacs=tmp_nb_transacs;

	TestFile.close();
}


void port_infos(int Portfolio[], infos_struct ALL_Infos[], int SSS[][N_], infos_struct * Port_Infos) {
	int s;
	int size_port=0;

	long tmp_nb_trades, tmp_nb_w_trades, tmp_nb_l_trades;
	double tmp_nb_days_per_trade, tmp_nb_days_per_w_trade, tmp_nb_days_per_l_trade;
	double tmp_return_per_trade, tmp_return_per_w_trade, tmp_return_per_l_trade;

	long tmp_nb_trades_L, tmp_nb_w_trades_L, tmp_nb_l_trades_L;
	double tmp_nb_days_per_trade_L, tmp_nb_days_per_w_trade_L, tmp_nb_days_per_l_trade_L;
	double tmp_return_per_trade_L, tmp_return_per_w_trade_L, tmp_return_per_l_trade_L;

	long tmp_nb_trades_S, tmp_nb_w_trades_S, tmp_nb_l_trades_S;
	double tmp_nb_days_per_trade_S, tmp_nb_days_per_w_trade_S, tmp_nb_days_per_l_trade_S;
	double tmp_return_per_trade_S, tmp_return_per_w_trade_S, tmp_return_per_l_trade_S;

	double tmp_prop_winning_signals, tmp_prop_neutral_signals, tmp_prop_losing_signals;

	tmp_nb_trades=0;
	tmp_nb_w_trades=0;
	tmp_nb_l_trades=0;
	tmp_nb_days_per_trade=0;
	tmp_nb_days_per_w_trade=0;
	tmp_nb_days_per_l_trade=0;
	tmp_return_per_trade=0;
	tmp_return_per_w_trade=0;
	tmp_return_per_l_trade=0;

	tmp_nb_trades_L=0;
	tmp_nb_w_trades_L=0;
	tmp_nb_l_trades_L=0;
	tmp_nb_days_per_trade_L=0;
	tmp_nb_days_per_w_trade_L=0;
	tmp_nb_days_per_l_trade_L=0;
	tmp_return_per_trade_L=0;
	tmp_return_per_w_trade_L=0;
	tmp_return_per_l_trade_L=0;
	
	tmp_nb_trades_S=0;
	tmp_nb_w_trades_S=0;
	tmp_nb_l_trades_S=0;
	tmp_nb_days_per_trade_S=0;
	tmp_nb_days_per_w_trade_S=0;
	tmp_nb_days_per_l_trade_S=0;
	tmp_return_per_trade_S=0;
	tmp_return_per_w_trade_S=0;
	tmp_return_per_l_trade_S=0;

	tmp_prop_winning_signals=0;
	tmp_prop_neutral_signals=0;
	tmp_prop_losing_signals=0;

	port_nb_transacs(Portfolio, SSS, Port_Infos);

	//ofstream TestFile, TestFile2;
	//TestFile.open("bob.txt", ofstream::out | ofstream::trunc);
	//TestFile2.open("bob2.txt", ofstream::out | ofstream::trunc);

	for(s=0; s<nb_strats_; s++) {
		if(Portfolio[s]==1) {
			size_port++;

			tmp_nb_trades+=ALL_Infos[s].nb_trades;
			tmp_nb_w_trades+=ALL_Infos[s].nb_w_trades;
			tmp_nb_l_trades+=ALL_Infos[s].nb_l_trades;
			tmp_nb_days_per_trade+=ALL_Infos[s].nb_days_per_trade*ALL_Infos[s].nb_trades;
			tmp_nb_days_per_w_trade+=ALL_Infos[s].nb_days_per_w_trade*ALL_Infos[s].nb_w_trades;
			tmp_nb_days_per_l_trade+=ALL_Infos[s].nb_days_per_l_trade*ALL_Infos[s].nb_l_trades;
			tmp_return_per_trade+=ALL_Infos[s].return_per_trade*ALL_Infos[s].nb_trades;
			tmp_return_per_w_trade+=ALL_Infos[s].return_per_w_trade*ALL_Infos[s].nb_w_trades;
			tmp_return_per_l_trade+=ALL_Infos[s].return_per_l_trade*ALL_Infos[s].nb_l_trades;
			tmp_nb_trades_L+=ALL_Infos[s].nb_trades_L;
			tmp_nb_w_trades_L+=ALL_Infos[s].nb_w_trades_L;
			tmp_nb_l_trades_L+=ALL_Infos[s].nb_l_trades_L;
			tmp_nb_days_per_trade_L+=ALL_Infos[s].nb_days_per_trade_L*ALL_Infos[s].nb_trades_L;
			tmp_nb_days_per_w_trade_L+=ALL_Infos[s].nb_days_per_w_trade_L*ALL_Infos[s].nb_w_trades_L;
			tmp_nb_days_per_l_trade_L+=ALL_Infos[s].nb_days_per_l_trade_L*ALL_Infos[s].nb_l_trades_L;
			tmp_return_per_trade_L+=ALL_Infos[s].return_per_trade_L*ALL_Infos[s].nb_trades_L;
			tmp_return_per_w_trade_L+=ALL_Infos[s].return_per_w_trade_L*ALL_Infos[s].nb_w_trades_L;
			tmp_return_per_l_trade_L+=ALL_Infos[s].return_per_l_trade_L*ALL_Infos[s].nb_l_trades_L;

			tmp_nb_trades_S+=ALL_Infos[s].nb_trades_S;
			tmp_nb_w_trades_S+=ALL_Infos[s].nb_w_trades_S;
			tmp_nb_l_trades_S+=ALL_Infos[s].nb_l_trades_S;
			tmp_nb_days_per_trade_S+=ALL_Infos[s].nb_days_per_trade_S*ALL_Infos[s].nb_trades_S;
			tmp_nb_days_per_w_trade_S+=ALL_Infos[s].nb_days_per_w_trade_S*ALL_Infos[s].nb_w_trades_S;
			tmp_nb_days_per_l_trade_S+=ALL_Infos[s].nb_days_per_l_trade_S*ALL_Infos[s].nb_l_trades_S;
			tmp_return_per_trade_S+=ALL_Infos[s].return_per_trade_S*ALL_Infos[s].nb_trades_S;
			tmp_return_per_w_trade_S+=ALL_Infos[s].return_per_w_trade_S*ALL_Infos[s].nb_w_trades_S;
			tmp_return_per_l_trade_S+=ALL_Infos[s].return_per_l_trade_S*ALL_Infos[s].nb_l_trades_S;

			tmp_prop_winning_signals+=ALL_Infos[s].prop_winning_signals;
			tmp_prop_neutral_signals+=ALL_Infos[s].prop_neutral_signals;
			tmp_prop_losing_signals+=ALL_Infos[s].prop_losing_signals;
		}
	}

	Port_Infos->nb_trades=tmp_nb_trades;
	Port_Infos->nb_w_trades=tmp_nb_w_trades;
	Port_Infos->nb_l_trades=tmp_nb_l_trades;
	Port_Infos->nb_days_per_trade= tmp_nb_trades==0 ? 0 : tmp_nb_days_per_trade/tmp_nb_trades;
	Port_Infos->nb_days_per_w_trade= tmp_nb_w_trades==0 ? 0 : tmp_nb_days_per_w_trade/tmp_nb_w_trades;
	Port_Infos->nb_days_per_l_trade= tmp_nb_l_trades==0 ? 0 : tmp_nb_days_per_l_trade/tmp_nb_l_trades;
	Port_Infos->return_per_trade= tmp_nb_trades==0 ? 0 : tmp_return_per_trade/tmp_nb_trades;
	Port_Infos->return_per_w_trade= tmp_nb_w_trades==0 ? 0 : tmp_return_per_w_trade/tmp_nb_w_trades;
	Port_Infos->return_per_l_trade= tmp_nb_l_trades==0 ? 0 : tmp_return_per_l_trade/tmp_nb_l_trades;

	Port_Infos->nb_trades_L=tmp_nb_trades_L;
	Port_Infos->nb_w_trades_L=tmp_nb_w_trades_L;
	Port_Infos->nb_l_trades_L=tmp_nb_l_trades_L;
	Port_Infos->nb_days_per_trade_L= tmp_nb_trades_L==0 ? 0 : tmp_nb_days_per_trade_L/tmp_nb_trades_L;
	Port_Infos->nb_days_per_w_trade_L= tmp_nb_w_trades_L==0 ? 0 : tmp_nb_days_per_w_trade_L/tmp_nb_w_trades_L;
	Port_Infos->nb_days_per_l_trade_L= tmp_nb_l_trades_L==0 ? 0 : tmp_nb_days_per_l_trade_L/tmp_nb_l_trades_L;
	Port_Infos->return_per_trade_L= tmp_nb_trades_L==0 ? 0 : tmp_return_per_trade_L/tmp_nb_trades_L;
	Port_Infos->return_per_w_trade_L= tmp_nb_w_trades_L==0 ? 0 : tmp_return_per_w_trade_L/tmp_nb_w_trades_L;
	Port_Infos->return_per_l_trade_L= tmp_nb_l_trades_L==0 ? 0 : tmp_return_per_l_trade_L/tmp_nb_l_trades_L;

	Port_Infos->nb_trades_S=tmp_nb_trades_S;
	Port_Infos->nb_w_trades_S=tmp_nb_w_trades_S;
	Port_Infos->nb_l_trades_S=tmp_nb_l_trades_S;
	Port_Infos->nb_days_per_trade_S= tmp_nb_trades_S==0 ? 0 : tmp_nb_days_per_trade_S/tmp_nb_trades_S;
	Port_Infos->nb_days_per_w_trade_S= tmp_nb_w_trades_S==0 ? 0 : tmp_nb_days_per_w_trade_S/tmp_nb_w_trades_S;
	Port_Infos->nb_days_per_l_trade_S= tmp_nb_l_trades_S==0 ? 0 : tmp_nb_days_per_l_trade_S/tmp_nb_l_trades_S;
	Port_Infos->return_per_trade_S= tmp_nb_trades_S==0 ? 0 : tmp_return_per_trade_S/tmp_nb_trades_S;
	Port_Infos->return_per_w_trade_S= tmp_nb_w_trades_S==0 ? 0 : tmp_return_per_w_trade_S/tmp_nb_w_trades_S;
	Port_Infos->return_per_l_trade_S= tmp_nb_l_trades_S==0 ? 0 : tmp_return_per_l_trade_S/tmp_nb_l_trades_S;

	Port_Infos->prop_winning_signals= size_port==0 ? 0 : tmp_prop_winning_signals/size_port;
	Port_Infos->prop_neutral_signals= size_port==0 ? 0 : tmp_prop_neutral_signals/size_port;
	Port_Infos->prop_losing_signals= size_port==0 ? 0 : tmp_prop_losing_signals/size_port;
}


