void ComputeReturnsOneStrat(int SS[], long R, long T, double TC, double LF, double DJ_Returns[], double RF[], double ReturnsOneStrat[], double ReturnsOneStrat_SR[], double RF_bis[]);
void ComputeReturnsOneStrat(int SS[], long R, long T, double TC, double LF, double DJ_Returns[], double RF[], double ReturnsOneStrat_SR[]);

void ComputeReturnsOneStrat(int SS[], long R, long T, double TC, double LF, double DJ_Returns[], double RF[], int NBER[], double ReturnsOneStrat[], double ReturnsOneStrat_SR[], double RF_bis[], 
							double ReturnsOneStrat_exp[], double ReturnsOneStrat_SR_exp[], double RF_bis_exp[], long * N_exp, 
							double ReturnsOneStrat_cont[], double ReturnsOneStrat_SR_cont[], double RF_bis_cont[], long * N_cont);

void ComputeReturnsOneStrat_noshort(int SS[], long R, long T, double TC, double LF, double DJ_Returns[], double RF[], double ReturnsOneStrat[], double ReturnsOneStrat_SR[], double RF_bis[], double * nbshort);

void ComputeReturnsOneStrat(int SS[], long R, long T, double TC, double LF, double DJ_Returns[], double RF[], int NBER[], double ReturnsOneStrat_SR[], double ReturnsOneStrat_SR_exp[], long * N_exp, 
							double ReturnsOneStrat_SR_cont[], long * N_cont);

void ComputeSR_ReturnsPorfolio_ptc_b(int SSS[][N_], long R, long T, double TC, double LF, double DJ_Returns[], 
									 double RF[], int Portfolio[], double oldproppos_init, double oldpropneg_init,
									 double SR_ReturnsPorfolio[], double * proppos_last, double * propneg_last, double RF_bis[]);
void ComputeSR_ReturnsPorfolio_ptc_b(int SSS[][N_], long R, long T, double TC, double LF, double DJ_Returns[], 
									 double RF[], int Portfolio[], double oldproppos_init, double oldpropneg_init,
									 double SR_ReturnsPorfolio[], double * proppos_last, double * propneg_last);
void ComputeSR_ReturnsPorfolio_ptc_b_nbshort(int SSS[][N_], long R, long T, double TC, double LF, double DJ_Returns[], 
									 double RF[], int Portfolio[], double oldproppos_init, double oldpropneg_init,
									 double SR_ReturnsPorfolio[], double * proppos_last, double * propneg_last, double * nbshort);

void ComputeSR_ReturnsPorfolio_ptc_noshort(int SSS[][N_], long R, long T, double TC, double LF, double DJ_Returns[], 
									 double RF[], int Portfolio[], double oldproppos_init,
									 double SR_ReturnsPorfolio[], double * proppos_last, double * nbshort);

double ComputeSR_nbporttransacs(int SSS[][N_], long R, long T, int Portfolio[]);

void Computemu_ReturnsPorfolio_ptc_b(int SSS[][N_], long R, long T, double TC, double LF, double DJ_Returns[], 
									 int Portfolio[], double oldproppos_init, double oldpropneg_init,
									 double output_ReturnsPorfolio[], double * proppos_last, double * propneg_last);

void Computemu_ReturnsPorfolio_ptc_noshort(int SSS[][N_], long R, long T, double TC, double LF, double DJ_Returns[], 
									 int Portfolio[], double oldproppos_init,
									 double output_ReturnsPorfolio[], double * proppos_last, double * nbshort);

double SharpeRatio(double DJ_ReturnsOneStrat_SR[], double RF[], long N);

double MeanReturn(double ReturnsOneStrat[], long N);

double Portfolio_SR_ptc(int SSS[][N_], long R, long T, double TC, double LF, double DJ_Returns[], double RF[], int Portfolio[]);

double Portfolio_mu_ptc(int SSS[][N_], long R, long T, double TC, double LF, double DJ_Returns[], int Portfolio[]);

void MultiPerfs(int SSS[][N_], long R, long T, double TC, double LF, double DJ_Returns[], double RF[], double Perfs[][nb_strats_]);
void MultiPerfs(int SSS[][N_], long R, long T, double TC, double LF, double DJ_Returns[], double RF[], double Perfs[][nb_strats_], double Sigmas[]);
void MultiPerfs(int SSS[nb_strats_][N_], long R, long T, double TC, double LF, double DJ_Returns[TT_], double RF[TT_], 
				long IDX[B_][N_], double Perfs[nb_perf_measures_][nb_strats_], 
				double pvalues[nb_perf_measures_][nb_strats_], double Perfs_B[nb_perf_measures_][B_][nb_strats_]);
void MultiPerfs(int SSS[nb_strats_][N_], long R, long T, double TC, double LF, double DJ_Returns[TT_], double RF[TT_], 
				long IDX[B_][N_], double Perfs[nb_perf_measures_][nb_strats_], 
				double pvalues[nb_perf_measures_][nb_strats_], double Perfs_B[nb_perf_measures_][B_][nb_strats_], double NBshort[nb_strats_]);

void MultiPerfs_noshort(int SSS[nb_strats_][N_], long R, long T, double TC, double LF, double DJ_Returns[TT_], double RF[TT_], 
				long IDX[B_][N_], double Perfs[nb_perf_measures_][nb_strats_], 
				double pvalues[nb_perf_measures_][nb_strats_], double Perfs_B[nb_perf_measures_][B_][nb_strats_], double NBshort[nb_strats_]);

void pvalues_BBB(double Perfs[][nb_strats_], long R, long T, double TC, double LF, double DJ_Returns[], double RF[], long IDX_BBB[][TT_], double pvalues[][nb_strats_], double Perfs_B[][B_][nb_strats_]);
void pvalues_BBB(double Perfs[][nb_strats_], long R, long T, double TC, double LF, double DJ_Returns[], double RF[], double OBVI[], long IDX_BBB[][TT_], double pvalues[][nb_strats_], double Perfs_B[][B_][nb_strats_]);

//double Portfolio_mu(double Perfs[], int Portfolio[]);

double Portfolio_mu_nber(int SSS[][N_], long R, long T, double TC, double LF, double DJ_Returns[], int NBER[], int Portfolio_exp[], int port_size_exp, int Portfolio_cont[], int port_size_cont);

void Best_portfolio(double Perfs[], int size, int Portfolio[]);

void Sort_by_categories(int Portfolio[], int NB_rules_by_categories[]);

void Sort_by_horizon(int Portfolio[], int SLOW[], int NB_rules_by_horizon[]);

void Compute_nb_trades(int SSS[][N_], long NB_trades[]);

double DJ_return_exp(long R, long T, int nber, double DJ_Returns[],  int NBER[]);


