#ifndef MY_UMGEBUNG_
#define MY_UMGEBUNG_

#include <string>

using namespace std;

const int B_=1000;

const double alpha_=.05;
const double myFDR_plus_=.1;
const double mygamma_=.01;
const double lambda_=.6;

const int best_portfolio_size_=50;

const long T_fin_year_=252;

const string boulot_path_="C:";
//const string boulot_path_="C:\\UNIGE";
//mac:
//const string boulot_path_="/Users/pierre/UNIGE";

const int nb_perf_measures_=2;
const string perf_measures_[]={"mu", "SR"};

//const int nb_TC_=1;
//const double TC_[]={0};
//const double LF_[]={0/252};
//const string tc_lf_paths_[]={"tc0_lf0"};

//const int nb_TC_=1;
//const double TC_[]={0.002};
//const double LF_[]={0.005/252};
//const string tc_lf_paths_[]={"tc20_lf50"};

//const int nb_TC_=1;
//const double TC_[]={0.01};
//const double LF_[]={0.005/252};
//const string tc_lf_paths_[]={"tc100_lf50"};

//const int nb_TC_=1;
//const double TC_[]={0.005};
//const double LF_[]={0.0025/252};
//const string tc_lf_paths_[]={"tc50_lf25"};

const int nb_TC_=1;
const double TC_[]={0.0025};
const double LF_[]={0.001/252};
const string tc_lf_paths_[]={"tc25_lf10"};

//const int nb_TC_=5;
//const double TC_[]={		0,			0,				0,			0.001,			0.001};
//const double LF_[]={		0/252,		0.005/252,		0.01/252,	0/252,			0.005/252};
//const string tc_lf_paths_[]={	"tc0_lf0",	"tc0_lf50",	"tc0_lf100",	"tc10_lf0",	"tc10_lf50"};
//const int nb_TC_=5;
//const double TC_[]={		0.001,			0.002,			0.002,			0.002,			0.003};
//const double LF_[]={		0.01/252,		0/252,			0.005/252,		0.01/252,		0/252};
//const string tc_lf_paths_[]={	"tc10_lf100",	"tc20_lf0",	"tc20_lf50",	"tc20_lf100",	"tc30_lf0"};
//const int nb_TC_=5;
//const double TC_[]={		0.003,			0.003,			0.004,			0.004,			0.004};
//const double LF_[]={		0.005/252,		0.01/252,		0/252,			0.005/252,		0.01/252};
//const string tc_lf_paths_[]={	"tc30_lf50",	"tc30_lf100",	"tc40_lf0",	"tc40_lf50",	"tc40_lf100"};

//const int nb_TC_=5;
//const double TC_[]={0,	0.001,	0.002,	0.003,	0.004};
//const double LF_[]={0,	0,		0,		0,		0};
//const string tc_lf_paths_[]={"tc0_lf0", "tc10_lf0", "tc20_lf0", "tc30_lf0", "tc40_lf0"};

const int nb_strats_=7846; //ALL
const int strats_categ_=0;
//const int nb_strats_=497; //que FR
//const int strats_categ_=1;
//const int nb_strats_=2049; //que MA
//const int strats_categ_=2;
//const int nb_strats_=1220; //que SR
//const int strats_categ_=3;
//const int nb_strats_=2040; //que CB
//const int strats_categ_=4;
//const int nb_strats_=2040; //que OBV
//const int strats_categ_=5;

//TT_:length of data series
//R_:date of first prediction (starting at t=1)
//T_:date of last prediction

//Jan 1897 - Dec 1914
const string period_="1";
const long TT_=5273;

//Jan 1915 - Dec 1938
//const string period_="2";
//const long TT_=7165;

//Jan 1939 - June 1962
//const string period_="3";
//const long TT_=6443;

//July 1962 - Dec 1986
//const string period_="4";
//const long TT_=6157;

//Jan 1987 - Dec 1996
//const string period_="5";
//const long TT_=2529;

//Jan 1997 - July 2011
//const string period_="6";
//const long TT_=3658;

//Jan 1897 - Dec 1986
//const string period_="90";
//const long TT_=25038;

//Jan 1897 - Dec 1996
//const string period_="100";
//const long TT_=27567;

//
//const string period_="DIA";
//const long TT_=2074;

const long R_=251;
const long T_=TT_-1;
const long N_=T_-R_+1;

struct strat_struct {
    int idx;
    double perf;
	double pvalue;
};

struct infos_struct {
	long nb_trades;
	long nb_w_trades;
	long nb_l_trades;
	double nb_days_per_trade;
	double nb_days_per_w_trade;
	double nb_days_per_l_trade;
	double return_per_trade;
	double return_per_w_trade;
	double return_per_l_trade;

	long nb_trades_L;
	long nb_w_trades_L;
	long nb_l_trades_L;
	double nb_days_per_trade_L;
	double nb_days_per_w_trade_L;
	double nb_days_per_l_trade_L;
	double return_per_trade_L;
	double return_per_w_trade_L;
	double return_per_l_trade_L;

	long nb_trades_S;
	long nb_w_trades_S;
	long nb_l_trades_S;
	double nb_days_per_trade_S;
	double nb_days_per_w_trade_S;
	double nb_days_per_l_trade_S;
	double return_per_trade_S;
	double return_per_w_trade_S;
	double return_per_l_trade_S;

	long nb_transacs;

	double prop_winning_signals;
	double prop_neutral_signals;
	double prop_losing_signals;
};

#endif
