% Read data from Excel file and create text files for C++ program

clear all
close all
clc

path='C:\DATA\dataprojet1';

% period='1';
% range=1:5273;
% period='2';
% range=5274:12438;
% period='3';
% range=12439:18881;
% period='4';
% range=18882:25038;
% period='5';
% range=25039:27567;
period='6';
range=27568:31225;
% period='100';
% range=1:27567;

Data=xlsread('data_all.xls');
Price=Data(:,1);
Vol=Data(:,2);
RiskFree=Data(:,3);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Returns=(Price(2:end)-Price(1:end-1))./Price(1:end-1);

Sign_Returns=[1; (Returns>0)-(Returns<=0)];
OBVI=Sign_Returns.*Vol;
OBVI=cumsum(OBVI);

Price=Price(range);
OBVI=OBVI(range);
RiskFree=RiskFree(range);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fid=fopen([path '\data\OBVI_P' period '.txt'],'wt');
fprintf(fid,'% 12.8e\n',OBVI);
fclose(fid);

fid=fopen([path '\data\DJ_P' period '.txt'],'wt');
fprintf(fid,'%8.2f\n',Price);
fclose(fid);

fid=fopen([path '\data\RF_P' period '.txt'],'wt');
fprintf(fid,'% 4.2f\n',RiskFree);
fclose(fid);




